.include "m32Adef.inc"
.def     Temp=R16
.def     Temp1=R17
.cseg
.org 0
rjmp RESET ; Reset Handler
nop
reti; EXT_INT0 ; IRQ0 Handler
nop
reti; EXT_INT1 ; IRQ1 Handler
nop
reti; EXT_INT2 ; IRQ2 Handler
nop
reti; TIM2_COMP ; Timer2 Compare Handler
nop
reti; TIM2_OVF ; Timer2 Overflow Handler
nop
reti; TIM1_CAPT ; Timer1 Capture Handler
nop
reti; TIM1_COMPA ; Timer1 CompareA Handler
nop
reti; TIM1_COMPB ; Timer1 CompareB Handler
nop
reti; TIM1_OVF ; Timer1 Overflow Handler
nop
reti; TIM0_COMP ; Timer0 Compare Handler
nop
reti; TIM0_OVF ; Timer0 Overflow Handler
nop
reti; SPI_STC ; SPI Transfer Complete Handler
nop
reti; USART_RXC ; USART RX Complete Handler
nop
reti; USART_UDRE ; UDR Empty Handler
nop
reti; USART_TXC ; USART TX Complete Handler
nop
reti; ADC ; ADC Conversion Complete Handler
nop
reti; EE_RDY ; EEPROM Ready Handler
nop
reti; ANA_COMP ; Analog Comparator Handler
nop
reti; TWI ; Two-wire Serial Interface Handler
nop
reti; SPM_RDY ; Store Program Memory Ready Handler
reset:

//////////////  ///////////////
ldi Temp,high(RamEnd)
out SPH,Temp
ldi Temp,low(RamEnd)
out SPL,Temp
ldi temp,255
out DDRA,temp  ;     ....
///////////////////////////////////

rcall i2c_init //  i2c
rcall i2c_start //   
ldi temp,0b10100000 //  
rcall i2c_send   
ldi temp,0  //    . 
rcall i2c_send

ldi temp1,0  //   
cikl: //
cpi temp1,16 // 16   
breq exitloop

mov temp,temp1 //      temp  
rcall i2c_send // 

inc temp1   //    1 
rjmp cikl
exitloop:  // 
rcall i2c_stop

rcall delay  //  

rcall i2c_start //   
ldi temp,0b10100000 // 
rcall i2c_send 
ldi temp,0x00 //   
rcall i2c_send
rcall i2c_start // !
ldi temp,0b10100001 //  +  !
rcall i2c_send 

//    16       

ldi temp1,0
cikl2:
cpi temp1,15
breq exitloop2

rcall i2c_recive
out PORTA,temp
rcall delay
inc temp1
rjmp cikl2
exitloop2:

rcall i2c_recive_last //     i2c_recive_last
out PORTA,temp
rcall i2c_stop


/////////////// ////////////////
Begin:
rjmp begin
///////////////////////////////////////////////



//////////////////    I2C //////////////////////
//////////////////    TEMP ///////////////////////
i2c_init: // 2
	ldi temp,5  
	out TWBR,temp
	ldi temp,(0<<TWPS1)|(0<<TWPS0)
	out TWSR,temp
ret

i2c_stop: //  
	ldi temp, (1<<TWINT)|(1<<TWEN)|(1<<TWSTO)
	out TWCR, temp
ret

i2c_start: //  
	ldi temp, (1<<TWINT)|(1<<TWSTA)|(1<<TWEN)
	out TWCR, temp
	wait1:
	in temp,TWCR
	sbrs temp,TWINT
	rjmp wait1
ret


i2c_recive_last: //      TEMP
	ldi temp, (1<<TWINT|1<<TWEN)
	out TWCR, temp
	wait3:
	in temp,TWCR
	sbrs temp,TWINT
	rjmp wait3
	in temp,TWDR
ret

i2c_recive: //      TEMP 
	ldi temp, (1<<TWINT|1<<TWEN|1<<TWEA)
	out TWCR, temp
	wait4:
	in temp,TWCR
	sbrs temp,TWINT
	rjmp wait4
	in temp,TWDR
ret

i2c_send: //     TEMP
	out TWDR,temp
	ldi temp, (1<<TWINT)|(1<<TWEN)
	out TWCR, temp
	wait2:
	in temp,TWCR
	sbrs temp,TWINT
	rjmp wait2
ret
///////////////////////////////////////////////////////////////////////





//////   ////////
delay:
; ============================= 
;    delay loop generator 
;     1600000 cycles:
; ----------------------------- 
; delaying 1599999 cycles:
          ldi  R18, $F1
WGLOOP0:  ldi  R19, $0E
WGLOOP1:  ldi  R20, $9D
WGLOOP2:  dec  R20
          brne WGLOOP2
          dec  R19
          brne WGLOOP1
          dec  R18
          brne WGLOOP0
; ----------------------------- 
; delaying 1 cycle:
          nop
; ============================= 
ret
//////////////////////////////////////
